﻿
$AAD_PRIVILEGED_ROLES = @{
    "62e90394-69f5-4237-9190-012177145e10" = "Global administrator"
    "9b895d92-2cd3-44c7-9d02-a6ac2d5ea5c3" = "Application administrator"
    "c4e39bd9-1100-46d3-8c65-fb160da0071f" = "Authentication administrator"
    "b0f54661-2d74-4c50-afa3-1ec803f12efe" = "Billing administrator"
    "158c047a-c907-4556-b7ef-446551a6b5f7" = "Cloud application administrator"
    "b1be1c3e-b65d-4f19-8427-f6fa0d97feb9" = "Conditional Access administrator"
    "29232cdf-9323-42fd-ade2-1d097af3e4de" = "Exchange administrator"
    "729827e3-9c14-49f7-bb1b-9608f156bbb8" = "Helpdesk administrator"
    "966707d0-3269-4727-9be2-8c3a10f19b9d" = "Password administrator"
    "7be44c8a-adaf-4e2a-84d6-ab2649e08a13" = "Privileged authentication administrator"
    "194ae4cb-b126-40b2-bd5b-6091b380977d" = "Security administrator"
    "f28a1f50-f6e7-4571-818b-6a12f2af6b6c" = "SharePoint administrator"
    "fe930be7-5e62-47db-91af-98c3a49a38b1" = "User administrator"
    "0526716b-113d-4c15-b2c8-68e3c22b9f80" = "Authentication Policy Administrator"
    "be2f45a1-457d-42af-a067-6ec1fa63bc45" = "External Identity Provider Administrator"
    "e8611ab8-c189-46e8-94e1-60213ab1f814" = "Privileged Role Administrator"
}

$DefinedPermissions = @{
    "Read Administrative Units" = @{
        "appRoleIds" = @(
            "134fd756-38ce-4afd-ba33-e9623dbe66c2",
            "7ab1d382-f21e-4acd-a863-ba3e13f7da61",
            "5eb59dd3-1da2-4329-8733-9dabdc435916",
            "19dbc75e-c2e2-444c-a770-ec69d8559fc7"
        );
        "LeastPrivilege" = "AdministrativeUnit.Read.All"
    }

    "Read Authorization Policy" = @{
        "appRoleIds" = @(
            "246dd0d5-5bd0-4def-940b-0421030a5b68",
            "fb221be6-99f2-473f-bd32-01c6a0e9ca3b"
        );
        "LeastPrivilege" = "Policy.Read.All"
    }

    "Read Policy" = @{
        "appRoleIds" = @(
            "246dd0d5-5bd0-4def-940b-0421030a5b68"
        );
        "LeastPrivilege" = "Policy.Read.All"
    }

    "Read Audit Logs" = @{
        "appRoleIds" = @(
            "b0afded3-3588-46d8-8b3d-9842eff778da"
        );
        "LeastPrivilege" = "AuditLog.Read.All"
    }

    "Read Directory Roles" = @{
        "appRoleIds" = @(
            "483bed4a-2ad3-4361-a73b-c83ccdbdc53c",
            "7ab1d382-f21e-4acd-a863-ba3e13f7da61",
            "9e3f62cf-ca93-4989-b6ce-bf83c28f9fe8",
            "19dbc75e-c2e2-444c-a770-ec69d8559fc7"
        );
        "LeastPrivilege" = "RoleManagement.Read.Directory"
    }

    "Read Role Schedule Instances" = @{
        "appRoleIds" = @(
            "ff278e11-4a33-4d0c-83d2-d01dc58929a5",
            "483bed4a-2ad3-4361-a73b-c83ccdbdc53c",
            "c7fbd983-d9aa-4fa7-84b8-17382c103bc4",
            "fee28b28-e1f3-4841-818e-2704dc62245f",
            "9e3f62cf-ca93-4989-b6ce-bf83c28f9fe8"
        );
        "LeastPrivilege" = "RoleEligibilitySchedule.Read.Directory"
    }

    "Read Directory Objects" = @{
        "appRoleIds" = @(
            "7ab1d382-f21e-4acd-a863-ba3e13f7da61"
        );
        "LeastPrivilege" = "Directory.Read.All"
    }

    "Read Users" = @{
        "appRoleIds" = @(
            "df021288-bdef-4463-88db-98f22de89214",
            "741f803b-c850-494e-b5df-cde7c675a1ca",
            "7ab1d382-f21e-4acd-a863-ba3e13f7da61",
            "19dbc75e-c2e2-444c-a770-ec69d8559fc7"
        );
        "LeastPrivilege" = "User.Read.All"
    }

    "Read Devices" = @{
        "appRoleIds" = @(
            "7438b122-aefc-4978-80ed-43db9fcc7715",
            "1138cb37-bd11-4084-a2b7-9f71582aeddb",
            "7ab1d382-f21e-4acd-a863-ba3e13f7da61",
            "19dbc75e-c2e2-444c-a770-ec69d8559fc7"
        );
        "LeastPrivilege" = "Device.Read.All"
    }

    "Read Reports" = @{
        "appRoleIds" = @(
            "230c1aed-a721-4c5d-9cb4-a90514e508ef"
        );
        "LeastPrivilege" = "Reports.Read.All"
    }

    "Read Applications" = @{
        "appRoleIds" = @(
            "d8e4ec18-f6c0-4620-8122-c8b1f2bf400e",
            "1bfefb4e-e0b5-418b-a88f-73c46d2cc8e9",
            "7ab1d382-f21e-4acd-a863-ba3e13f7da61"
        );
        "LeastPrivilege" = "Application.Read.All"
    }

    "Read Groups" = @{
        "appRoleIds" = @(
            "98830695-27a2-44f7-8c18-0c3ebc9698f6",
            "5b567255-7703-4780-807c-7be8301ae99b",
            "7ab1d382-f21e-4acd-a863-ba3e13f7da61",
            "62a82d76-70ea-41e2-9197-370581804d09",
            "19dbc75e-c2e2-444c-a770-ec69d8559fc7"
        );
        "LeastPrivilege" = "GroupMember.Read.All"
    }

    "Read User Authentication Method" = @{
        "appRoleIds" = @(
            "38d9df27-64da-44fd-b7c5-a6fbac20248f",
            "50483e42-d915-4231-9639-7fdb7fd190e5"
        );
        "LeastPrivilege" = "UserAuthenticationMethod.Read.All"
    }

    "Role Eligibility Schedule Instances" = @{
        "appRoleIds" = @(
            "c7fbd983-d9aa-4fa7-84b8-17382c103bc4",
            "483bed4a-2ad3-4361-a73b-c83ccdbdc53c",
            "9e3f62cf-ca93-4989-b6ce-bf83c28f9fe8"
        );
        "LeastPrivilege" = "RoleManagement.Read.All"
    }
}

$Script:RefreshTokens = @{}

function Get-GraphApiToken {
    <#
    .SYNOPSIS
        Returns access token for specified tenant using security credentials
    #>
    [CmdletBinding()]
    param(
        [Parameter(Mandatory)]
        [string] $TenantId,

        [Parameter(Mandatory)]
        [string] $TenantAppId,

        [Parameter(Mandatory)]
        [string] $TenantAppSecret,

        [string] $Scope = 'https://graph.microsoft.com/.default',

        # Unused. Simplify calling syntax by using @PSBoundParameters
        $ForestName, $DomainNames
    )

    $getToken = @{
        Method = 'POST'
        Uri = "https://login.microsoftonline.com/$($TenantId)/oauth2/v2.0/token"
        Body = @{
            client_id = $TenantAppId
            client_secret = $TenantAppSecret
            scope = $Scope
            grant_type = 'client_credentials'
        }
        ContentType = 'application/x-www-form-urlencoded'
    }

    $tokenResult = Invoke-RestMethod @getToken
    $accessToken = $tokenResult.access_token

    # Store credentials, used to get this particular token
    $Script:RefreshTokens[$accessToken] = $PSBoundParameters

    return $accessToken
}

function Update-GraphApiToken {
    <#
    .SYNOPSIS
        Retrieves new token using previously used credentials

    .PARAMETER AccessToken
        Previously used and expired token
    #>
    [CmdletBinding()]
    param(
        [Parameter(Mandatory, ValueFromPipeline)]
        [ValidateNotNullOrEmpty()]
        [string] $AccessToken
    )
    process {
        Write-Warning 'Updating Azure Graph API Token'
        $credentials = $Script:RefreshTokens[$AccessToken]
        if($credentials) {
            $newToken = Get-GraphApiToken @credentials
            Write-Verbose "New Graph API token received: $($newToken.Substring(0, 8))..."
            return $newToken
        }
        Write-Error 'Cannot update Graph API Token'
    }
}

function Invoke-GraphApiRequest {
    <#
    .SYNOPSIS
        Invokes REST call to Graph API
    .NOTES
        Automatically handles token expiration and @odata.next page iteration
    .NOTES
        Calls to /$batch API combine all results into single array of objects
    #>
    [CmdletBinding()]
    param(
        [Parameter(Mandatory)]
        [ValidateNotNullOrEmpty()]
        [Uri] $Uri,

        [ValidateNotNullOrEmpty()]
        [string] $Method = 'GET',

        $Body,

        [ValidateNotNullOrEmpty()]
        [string] $ContentType = 'application/json',

        [Parameter(Mandatory)]
        [ValidateNotNullOrEmpty()]
        [string] $AccessToken,

        [int] $Attempts = 3
    )
    $request = @{
        Uri = $Uri
        Method = $Method
        ContentType = $ContentType
        Headers = @{
            Authorization = "Bearer $AccessToken"
        }
    }

    if ($Body) {
        $request.Body = $Body
    }

    try {
        $response = Invoke-RestMethod @request

        $isBatch = $Uri -like '*/$batch'
        if ($isBatch) {
            $requests = $Body | ConvertFrom-Json | Select-Object -ExpandProperty 'requests'
            $results = @()
            foreach ($result in $response.responses) {
                if ($result.status -eq 403) {
                    throw New-Object 'Exception' | Add-Member -PassThru -NotePropertyMembers @{
                        Response = @{ StatusCode = 403 }
                    }
                }

                $batchResult = $result.body.value
                $batchError = $result.body.error

                if ($batchError) {
                    Write-Warning "Batch error occured: $($batchError.message)"
                    $failedRequest = $requests | Where-Object -Property 'id' -Value $result.id

                    $batchRetry = @{
                        Uri = [Uri]::new($Uri, $failedRequest.Uri)
                        Method = $failedRequest.Method
                        AccessToken = $AccessToken
                        ContentType = $ContentType
                        Body = (if ($failedRequest.Body) { ConvertTo-Json $failedRequest.Body -Compress })
                    }
                    $retried = Invoke-GraphApiRequest @batchRetry
                    $batchResult = $retried.value
                }

                if ($batchResult) {
                    $results += $batchResult
                }
            }
            $response = $results
        }
        else {
            $nextPage = $response.'@odata.nextLink'

            if ($null -ne $nextPage) {
                $innerRequest = @{
                    Uri = $nextPage
                    Method = 'GET'
                    ContentType = $ContentType
                    AccessToken = $AccessToken
                    Attempts = $Attempts
                }

                # Combine all pages into a single response
                $response.value += @(
                    Invoke-GraphApiRequest @innerRequest |
                        Select-Object -ExpandProperty 'value'
                )

                # Reset next link to avoid accidental iteration in indicator code
                $response.'@odata.nextLink' = $null
            }
        }
        return $response
    }
    catch {
        $httpStatus = [int]$_.Exception.Response.StatusCode
        $shouldRetry = $false

        if ($httpStatus -eq 429 <#Too Many Requests#>) {
            Write-Warning "The request has failed due to Azure Graph API throttling"
            $shouldRetry = $true
        }
        elseif ($httpStatus -eq 401 <#Unauthorized#>) {
            Write-Warning 'The request has failed because of expired Graph Access Token'
            $AccessToken = Update-GraphApiToken $AccessToken
            $shouldRetry = $true
        }
        elseif ($httpStatus -eq 400 <#Bad Request#>) {
            if ($request.Uri.OriginalString -match "roleEligibilityScheduleInstances") {
                return [PSCustomObject] @{ value = @() }
            }
        }

        if ($shouldRetry -and $Attempts -gt 0) {
            Start-Sleep -Seconds (Get-Random -Minimum 1 -Maximum (8 - $Attempts * 2))

            $retry = @{
                Uri = $Uri
                Method = $Method
                AccessToken = $AccessToken
                Body = $Body
                Attempts = ($Attempts - 1)
            }
            return Invoke-GraphApiRequest @retry
        }

        throw
    }
}

function ConvertTo-GraphApiErrorResult {
    <#
    .SYNOPSIS
        Provides unified global exception handling for Graph API errors
    #>
    #[CmdletBinding()]
    param (
        [Parameter(ValueFromPipeline)]
        $ErrorObject,

        [string] $AccessToken,
        [string] $TenantAppId,
        [string[]] $RequiredPrivileges
    )
    process {
        if ([int]$_.Exception.Response.Statuscode -eq 403) {
            $result = New-Object Semperis.PSSecurityIndicatorResult.SecurityIndicatorResult
            $result.Status = 'Error'

            $context = @{
                TenantAppId = $TenantAppId
                AccessToken = $AccessToken
                RequiredPrivileges = $RequiredPrivileges
            }
            $permissions = Get-GraphApiRequiredPermission @context

            if ($permissions.Message -match "P1") {
                $result.Status = 'NotRelevant'
                $result.ResultMessage = 'This indicator is relevant only when a P1 or P2 license is in place'
            }
            else {
                $result.ResultMessage = $permissions.Message
                $result.Remediation = $permissions.Remediation
            }

            return $result

        }
        ConvertTo-ErrorResult $ErrorObject
    }
}
function Get-GraphApiRequiredPermission {
    #[CmdletBinding()]
    [OutputType([hashtable])]
    param (
        $TenantAppId,
        [string[]] $RequiredPrivileges,
        $AccessToken
    )
    $getPrincipal = @{
        Uri = "https://graph.microsoft.com/v1.0/servicePrincipals/?`$filter=appid eq '$TenantAppId'"
        AccessToken = $AccessToken
    }
    $appIDResult = Invoke-GraphApiRequest @getPrincipal
    $principalId = $appIDResult.value.id

    $getRoleAssignments = @{
        Uri = "https://graph.microsoft.com/v1.0/servicePrincipals/$principalId/appRoleAssignments"
        AccessToken = $AccessToken
    }

    $appIDAssignments = @()
    $appAssignmentResult = Invoke-GraphApiRequest @getRoleAssignments
    $appIDAssignments += $appAssignmentResult.value | Where-Object {$_.resourceDisplayName -eq "Microsoft Graph"}

    $appIDAssignmentRoleIds = @()
    $appIDAssignmentRoleIds += $appIDAssignments.appRoleId

    $neededPrivs = [System.Collections.ArrayList]$RequiredPrivileges
    foreach ($privilege in $RequiredPrivileges) {
        foreach ($roleId in $appIDAssignmentRoleIds) {
            if ($DefinedPermissions[$privilege].appRoleIds -contains $roleId) {
                [void]$neededPrivs.Remove($privilege)
            }
        }
    }

    $missingPrivs = @()
    foreach ($neededPriv in $neededPrivs) {
        $missingPrivs += $DefinedPermissions[$neededPriv].LeastPrivilege
    }

    if ($missingPrivs.Count -gt 0) {
        return @{
            Message = "Insufficient permissions"
            Remediation = "Please ensure your DSP app has the following Graph API permission(s): $($missingPrivs -join ", ")"
        }
    }
    else {
        return @{
            Message = "This indicator requires a P1 or P2 license"
        }
    }
}

<#
.SYNOPSIS
Gets Azure audit logs for a given filter

.DESCRIPTION
Queries Azure audit logs for entries matching filter

.PARAMETER auditFilter
Filter to use while searching audit logs

.EXAMPLE
Get-AADAuditLog -auditFilter $filter
#>
Function Get-AADAuditLog {
    param(
        [parameter(Mandatory = $true)]
        [string]$AuditFilter,

        [parameter(Mandatory = $true)]
        [string]$Token,

        [parameter(Mandatory = $false)]
        [switch]$Regex = $false,

        [parameter(Mandatory = $false)]
        [String[]]$NewValues
    )

    Out-Log -Operation $MyInvocation.MyCommand.Name -Data $PSBoundParameters

    $getAuditLogs = @{
        Uri = "https://graph.microsoft.com/v1.0/auditLogs/directoryAudits?`$filter=$AuditFilter"
        AccessToken = $Token
    }

    try {
        $auditLogResults = Invoke-GraphApiRequest @getAuditLogs
    }
    catch {
        return $_ | ConvertTo-GraphApiErrorResult -RequiredPrivileges 'Read Audit Logs' -TenantAppId $TenantAppId -AccessToken $graphAccess
    }

    $auditLogs = [System.Collections.ArrayList]@()
    $filteredResults = @()

    if ($newValues) {
        foreach ($newValue in $newValues) {
            if ($Regex) {
                $filteredResults += $auditLogResults.value | Where-Object {$_.targetResources.modifiedProperties.newValue -match "`"$newValue`""}
            }
            else {
                $filteredResults += $auditLogResults.value | Where-Object {$_.targetResources.modifiedProperties.newValue -eq "`"$newValue`""}
            }
        }
        $auditLogs.AddRange($filteredResults)
    }
    else {
        $auditLogs.AddRange($auditLogResults.value)
    }

    return $auditLogs
}

Export-ModuleMember -Variable AAD_PRIVILEGED_ROLES
Export-ModuleMember -Function Get-GraphApiToken
Export-ModuleMember -Function Get-AADAuditLog
Export-ModuleMember -Function Invoke-GraphApiRequest
Export-ModuleMember -Function ConvertTo-GraphApiErrorResult
# SIG # Begin signature block
# MIItmQYJKoZIhvcNAQcCoIItijCCLYYCAQExDzANBglghkgBZQMEAgEFADB5Bgor
# BgEEAYI3AgEEoGswaTA0BgorBgEEAYI3AgEeMCYCAwEAAAQQH8w7YFlLCE63JNLG
# KX7zUQIBAAIBAAIBAAIBAAIBADAxMA0GCWCGSAFlAwQCAQUABCBrM4ZOamkre5QL
# 0ptz5gUB2mJ4LvVJVwCRBRYLkY+em6CCJrkwggWNMIIEdaADAgECAhAOmxiO+dAt
# 5+/bUOIIQBhaMA0GCSqGSIb3DQEBDAUAMGUxCzAJBgNVBAYTAlVTMRUwEwYDVQQK
# EwxEaWdpQ2VydCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xJDAiBgNV
# BAMTG0RpZ2lDZXJ0IEFzc3VyZWQgSUQgUm9vdCBDQTAeFw0yMjA4MDEwMDAwMDBa
# Fw0zMTExMDkyMzU5NTlaMGIxCzAJBgNVBAYTAlVTMRUwEwYDVQQKEwxEaWdpQ2Vy
# dCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xITAfBgNVBAMTGERpZ2lD
# ZXJ0IFRydXN0ZWQgUm9vdCBHNDCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCCAgoC
# ggIBAL/mkHNo3rvkXUo8MCIwaTPswqclLskhPfKK2FnC4SmnPVirdprNrnsbhA3E
# MB/zG6Q4FutWxpdtHauyefLKEdLkX9YFPFIPUh/GnhWlfr6fqVcWWVVyr2iTcMKy
# unWZanMylNEQRBAu34LzB4TmdDttceItDBvuINXJIB1jKS3O7F5OyJP4IWGbNOsF
# xl7sWxq868nPzaw0QF+xembud8hIqGZXV59UWI4MK7dPpzDZVu7Ke13jrclPXuU1
# 5zHL2pNe3I6PgNq2kZhAkHnDeMe2scS1ahg4AxCN2NQ3pC4FfYj1gj4QkXCrVYJB
# MtfbBHMqbpEBfCFM1LyuGwN1XXhm2ToxRJozQL8I11pJpMLmqaBn3aQnvKFPObUR
# WBf3JFxGj2T3wWmIdph2PVldQnaHiZdpekjw4KISG2aadMreSx7nDmOu5tTvkpI6
# nj3cAORFJYm2mkQZK37AlLTSYW3rM9nF30sEAMx9HJXDj/chsrIRt7t/8tWMcCxB
# YKqxYxhElRp2Yn72gLD76GSmM9GJB+G9t+ZDpBi4pncB4Q+UDCEdslQpJYls5Q5S
# UUd0viastkF13nqsX40/ybzTQRESW+UQUOsxxcpyFiIJ33xMdT9j7CFfxCBRa2+x
# q4aLT8LWRV+dIPyhHsXAj6KxfgommfXkaS+YHS312amyHeUbAgMBAAGjggE6MIIB
# NjAPBgNVHRMBAf8EBTADAQH/MB0GA1UdDgQWBBTs1+OC0nFdZEzfLmc/57qYrhwP
# TzAfBgNVHSMEGDAWgBRF66Kv9JLLgjEtUYunpyGd823IDzAOBgNVHQ8BAf8EBAMC
# AYYweQYIKwYBBQUHAQEEbTBrMCQGCCsGAQUFBzABhhhodHRwOi8vb2NzcC5kaWdp
# Y2VydC5jb20wQwYIKwYBBQUHMAKGN2h0dHA6Ly9jYWNlcnRzLmRpZ2ljZXJ0LmNv
# bS9EaWdpQ2VydEFzc3VyZWRJRFJvb3RDQS5jcnQwRQYDVR0fBD4wPDA6oDigNoY0
# aHR0cDovL2NybDMuZGlnaWNlcnQuY29tL0RpZ2lDZXJ0QXNzdXJlZElEUm9vdENB
# LmNybDARBgNVHSAECjAIMAYGBFUdIAAwDQYJKoZIhvcNAQEMBQADggEBAHCgv0Nc
# Vec4X6CjdBs9thbX979XB72arKGHLOyFXqkauyL4hxppVCLtpIh3bb0aFPQTSnov
# Lbc47/T/gLn4offyct4kvFIDyE7QKt76LVbP+fT3rDB6mouyXtTP0UNEm0Mh65Zy
# oUi0mcudT6cGAxN3J0TU53/oWajwvy8LpunyNDzs9wPHh6jSTEAZNUZqaVSwuKFW
# juyk1T3osdz9HNj0d1pcVIxv76FQPfx2CWiEn2/K2yCNNWAcAgPLILCsWKAOQGPF
# mCLBsln1VWvPJ6tsds5vIy30fnFqI2si/xK4VC0nftg62fC2h5b9W9FcrBjDTZ9z
# twGpn1eqXijiuZQwggWiMIIEiqADAgECAhB4AxhCRXCKQc9vAbjutKlUMA0GCSqG
# SIb3DQEBDAUAMEwxIDAeBgNVBAsTF0dsb2JhbFNpZ24gUm9vdCBDQSAtIFIzMRMw
# EQYDVQQKEwpHbG9iYWxTaWduMRMwEQYDVQQDEwpHbG9iYWxTaWduMB4XDTIwMDcy
# ODAwMDAwMFoXDTI5MDMxODAwMDAwMFowUzELMAkGA1UEBhMCQkUxGTAXBgNVBAoT
# EEdsb2JhbFNpZ24gbnYtc2ExKTAnBgNVBAMTIEdsb2JhbFNpZ24gQ29kZSBTaWdu
# aW5nIFJvb3QgUjQ1MIICIjANBgkqhkiG9w0BAQEFAAOCAg8AMIICCgKCAgEAti3F
# MN166KuQPQNysDpLmRZhsuX/pWcdNxzlfuyTg6qE9aNDm5hFirhjV12bAIgEJen4
# aJJLgthLyUoD86h/ao+KYSe9oUTQ/fU/IsKjT5GNswWyKIKRXftZiAULlwbCmPgs
# pzMk7lA6QczwoLB7HU3SqFg4lunf+RuRu4sQLNLHQx2iCXShgK975jMKDFlrjrz0
# q1qXe3+uVfuE8ID+hEzX4rq9xHWhb71hEHREspgH4nSr/2jcbCY+6R/l4ASHrTDT
# DI0DfFW4FnBcJHggJetnZ4iruk40mGtwEd44ytS+ocCc4d8eAgHYO+FnQ4S2z/x0
# ty+Eo7+6CTc9Z2yxRVwZYatBg/WsHet3DUZHc86/vZWV7Z0riBD++ljop1fhs8+o
# WukHJZsSxJ6Acj2T3IyU3ztE5iaA/NLDA/CMDNJF1i7nj5ie5gTuQm5nfkIWcWLn
# BPlgxmShtpyBIU4rxm1olIbGmXRzZzF6kfLUjHlufKa7fkZvTcWFEivPmiJECKiF
# N84HYVcGFxIkwMQxc6GYNVdHfhA6RdktpFGQmKmgBzfEZRqqHGsWd/enl+w/GTCZ
# bzH76kCy59LE+snQ8FB2dFn6jW0XMr746X4D9OeHdZrUSpEshQMTAitCgPKJajbP
# yEygzp74y42tFqfT3tWbGKfGkjrxgmPxLg4kZN8CAwEAAaOCAXcwggFzMA4GA1Ud
# DwEB/wQEAwIBhjATBgNVHSUEDDAKBggrBgEFBQcDAzAPBgNVHRMBAf8EBTADAQH/
# MB0GA1UdDgQWBBQfAL9GgAr8eDm3pbRD2VZQu86WOzAfBgNVHSMEGDAWgBSP8Et/
# qC5FJK5NUPpjmove4t0bvDB6BggrBgEFBQcBAQRuMGwwLQYIKwYBBQUHMAGGIWh0
# dHA6Ly9vY3NwLmdsb2JhbHNpZ24uY29tL3Jvb3RyMzA7BggrBgEFBQcwAoYvaHR0
# cDovL3NlY3VyZS5nbG9iYWxzaWduLmNvbS9jYWNlcnQvcm9vdC1yMy5jcnQwNgYD
# VR0fBC8wLTAroCmgJ4YlaHR0cDovL2NybC5nbG9iYWxzaWduLmNvbS9yb290LXIz
# LmNybDBHBgNVHSAEQDA+MDwGBFUdIAAwNDAyBggrBgEFBQcCARYmaHR0cHM6Ly93
# d3cuZ2xvYmFsc2lnbi5jb20vcmVwb3NpdG9yeS8wDQYJKoZIhvcNAQEMBQADggEB
# AKz3zBWLMHmoHQsoiBkJ1xx//oa9e1ozbg1nDnti2eEYXLC9E10dI645UHY3qkT9
# XwEjWYZWTMytvGQTFDCkIKjgP+icctx+89gMI7qoLao89uyfhzEHZfU5p1GCdeHy
# L5f20eFlloNk/qEdUfu1JJv10ndpvIUsXPpYd9Gup7EL4tZ3u6m0NEqpbz308w2V
# Xeb5ekWwJRcxLtv3D2jmgx+p9+XUnZiM02FLL8Mofnrekw60faAKbZLEtGY/fadY
# 7qz37MMIAas4/AocqcWXsojICQIZ9lyaGvFNbDDUswarAGBIDXirzxetkpNiIHd1
# bL3IMrTcTevZ38GQlim9wX8wggauMIIElqADAgECAhAHNje3JFR82Ees/ShmKl5b
# MA0GCSqGSIb3DQEBCwUAMGIxCzAJBgNVBAYTAlVTMRUwEwYDVQQKEwxEaWdpQ2Vy
# dCBJbmMxGTAXBgNVBAsTEHd3dy5kaWdpY2VydC5jb20xITAfBgNVBAMTGERpZ2lD
# ZXJ0IFRydXN0ZWQgUm9vdCBHNDAeFw0yMjAzMjMwMDAwMDBaFw0zNzAzMjIyMzU5
# NTlaMGMxCzAJBgNVBAYTAlVTMRcwFQYDVQQKEw5EaWdpQ2VydCwgSW5jLjE7MDkG
# A1UEAxMyRGlnaUNlcnQgVHJ1c3RlZCBHNCBSU0E0MDk2IFNIQTI1NiBUaW1lU3Rh
# bXBpbmcgQ0EwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIKAoICAQDGhjUGSbPB
# PXJJUVXHJQPE8pE3qZdRodbSg9GeTKJtoLDMg/la9hGhRBVCX6SI82j6ffOciQt/
# nR+eDzMfUBMLJnOWbfhXqAJ9/UO0hNoR8XOxs+4rgISKIhjf69o9xBd/qxkrPkLc
# Z47qUT3w1lbU5ygt69OxtXXnHwZljZQp09nsad/ZkIdGAHvbREGJ3HxqV3rwN3mf
# XazL6IRktFLydkf3YYMZ3V+0VAshaG43IbtArF+y3kp9zvU5EmfvDqVjbOSmxR3N
# Ng1c1eYbqMFkdECnwHLFuk4fsbVYTXn+149zk6wsOeKlSNbwsDETqVcplicu9Yem
# j052FVUmcJgmf6AaRyBD40NjgHt1biclkJg6OBGz9vae5jtb7IHeIhTZgirHkr+g
# 3uM+onP65x9abJTyUpURK1h0QCirc0PO30qhHGs4xSnzyqqWc0Jon7ZGs506o9UD
# 4L/wojzKQtwYSH8UNM/STKvvmz3+DrhkKvp1KCRB7UK/BZxmSVJQ9FHzNklNiyDS
# LFc1eSuo80VgvCONWPfcYd6T/jnA+bIwpUzX6ZhKWD7TA4j+s4/TXkt2ElGTyYwM
# O1uKIqjBJgj5FBASA31fI7tk42PgpuE+9sJ0sj8eCXbsq11GdeJgo1gJASgADoRU
# 7s7pXcheMBK9Rp6103a50g5rmQzSM7TNsQIDAQABo4IBXTCCAVkwEgYDVR0TAQH/
# BAgwBgEB/wIBADAdBgNVHQ4EFgQUuhbZbU2FL3MpdpovdYxqII+eyG8wHwYDVR0j
# BBgwFoAU7NfjgtJxXWRM3y5nP+e6mK4cD08wDgYDVR0PAQH/BAQDAgGGMBMGA1Ud
# JQQMMAoGCCsGAQUFBwMIMHcGCCsGAQUFBwEBBGswaTAkBggrBgEFBQcwAYYYaHR0
# cDovL29jc3AuZGlnaWNlcnQuY29tMEEGCCsGAQUFBzAChjVodHRwOi8vY2FjZXJ0
# cy5kaWdpY2VydC5jb20vRGlnaUNlcnRUcnVzdGVkUm9vdEc0LmNydDBDBgNVHR8E
# PDA6MDigNqA0hjJodHRwOi8vY3JsMy5kaWdpY2VydC5jb20vRGlnaUNlcnRUcnVz
# dGVkUm9vdEc0LmNybDAgBgNVHSAEGTAXMAgGBmeBDAEEAjALBglghkgBhv1sBwEw
# DQYJKoZIhvcNAQELBQADggIBAH1ZjsCTtm+YqUQiAX5m1tghQuGwGC4QTRPPMFPO
# vxj7x1Bd4ksp+3CKDaopafxpwc8dB+k+YMjYC+VcW9dth/qEICU0MWfNthKWb8RQ
# TGIdDAiCqBa9qVbPFXONASIlzpVpP0d3+3J0FNf/q0+KLHqrhc1DX+1gtqpPkWae
# LJ7giqzl/Yy8ZCaHbJK9nXzQcAp876i8dU+6WvepELJd6f8oVInw1YpxdmXazPBy
# oyP6wCeCRK6ZJxurJB4mwbfeKuv2nrF5mYGjVoarCkXJ38SNoOeY+/umnXKvxMfB
# wWpx2cYTgAnEtp/Nh4cku0+jSbl3ZpHxcpzpSwJSpzd+k1OsOx0ISQ+UzTl63f8l
# Y5knLD0/a6fxZsNBzU+2QJshIUDQtxMkzdwdeDrknq3lNHGS1yZr5Dhzq6YBT70/
# O3itTK37xJV77QpfMzmHQXh6OOmc4d0j/R0o08f56PGYX/sr2H7yRp11LB4nLCbb
# bxV7HhmLNriT1ObyF5lZynDwN7+YAN8gFk8n+2BnFqFmut1VwDophrCYoCvtlUG3
# OtUVmDG0YgkPCr2B2RP+v6TR81fZvAT6gt4y3wSJ8ADNXcL50CN/AAvkdgIm2fBl
# dkKmKYcJRyvmfxqkhQ/8mJb2VVQrH4D6wPIOK+XW+6kvRBVK5xMOHds3OBqhK/bt
# 1nz8MIIGwjCCBKqgAwIBAgIQBUSv85SdCDmmv9s/X+VhFjANBgkqhkiG9w0BAQsF
# ADBjMQswCQYDVQQGEwJVUzEXMBUGA1UEChMORGlnaUNlcnQsIEluYy4xOzA5BgNV
# BAMTMkRpZ2lDZXJ0IFRydXN0ZWQgRzQgUlNBNDA5NiBTSEEyNTYgVGltZVN0YW1w
# aW5nIENBMB4XDTIzMDcxNDAwMDAwMFoXDTM0MTAxMzIzNTk1OVowSDELMAkGA1UE
# BhMCVVMxFzAVBgNVBAoTDkRpZ2lDZXJ0LCBJbmMuMSAwHgYDVQQDExdEaWdpQ2Vy
# dCBUaW1lc3RhbXAgMjAyMzCCAiIwDQYJKoZIhvcNAQEBBQADggIPADCCAgoCggIB
# AKNTRYcdg45brD5UsyPgz5/X5dLnXaEOCdwvSKOXejsqnGfcYhVYwamTEafNqrJq
# 3RApih5iY2nTWJw1cb86l+uUUI8cIOrHmjsvlmbjaedp/lvD1isgHMGXlLSlUIHy
# z8sHpjBoyoNC2vx/CSSUpIIa2mq62DvKXd4ZGIX7ReoNYWyd/nFexAaaPPDFLnkP
# G2ZS48jWPl/aQ9OE9dDH9kgtXkV1lnX+3RChG4PBuOZSlbVH13gpOWvgeFmX40Qr
# StWVzu8IF+qCZE3/I+PKhu60pCFkcOvV5aDaY7Mu6QXuqvYk9R28mxyyt1/f8O52
# fTGZZUdVnUokL6wrl76f5P17cz4y7lI0+9S769SgLDSb495uZBkHNwGRDxy1Uc2q
# TGaDiGhiu7xBG3gZbeTZD+BYQfvYsSzhUa+0rRUGFOpiCBPTaR58ZE2dD9/O0V6M
# qqtQFcmzyrzXxDtoRKOlO0L9c33u3Qr/eTQQfqZcClhMAD6FaXXHg2TWdc2PEnZW
# pST618RrIbroHzSYLzrqawGw9/sqhux7UjipmAmhcbJsca8+uG+W1eEQE/5hRwqM
# /vC2x9XH3mwk8L9CgsqgcT2ckpMEtGlwJw1Pt7U20clfCKRwo+wK8REuZODLIivK
# 8SgTIUlRfgZm0zu++uuRONhRB8qUt+JQofM604qDy0B7AgMBAAGjggGLMIIBhzAO
# BgNVHQ8BAf8EBAMCB4AwDAYDVR0TAQH/BAIwADAWBgNVHSUBAf8EDDAKBggrBgEF
# BQcDCDAgBgNVHSAEGTAXMAgGBmeBDAEEAjALBglghkgBhv1sBwEwHwYDVR0jBBgw
# FoAUuhbZbU2FL3MpdpovdYxqII+eyG8wHQYDVR0OBBYEFKW27xPn783QZKHVVqll
# MaPe1eNJMFoGA1UdHwRTMFEwT6BNoEuGSWh0dHA6Ly9jcmwzLmRpZ2ljZXJ0LmNv
# bS9EaWdpQ2VydFRydXN0ZWRHNFJTQTQwOTZTSEEyNTZUaW1lU3RhbXBpbmdDQS5j
# cmwwgZAGCCsGAQUFBwEBBIGDMIGAMCQGCCsGAQUFBzABhhhodHRwOi8vb2NzcC5k
# aWdpY2VydC5jb20wWAYIKwYBBQUHMAKGTGh0dHA6Ly9jYWNlcnRzLmRpZ2ljZXJ0
# LmNvbS9EaWdpQ2VydFRydXN0ZWRHNFJTQTQwOTZTSEEyNTZUaW1lU3RhbXBpbmdD
# QS5jcnQwDQYJKoZIhvcNAQELBQADggIBAIEa1t6gqbWYF7xwjU+KPGic2CX/yyzk
# zepdIpLsjCICqbjPgKjZ5+PF7SaCinEvGN1Ott5s1+FgnCvt7T1IjrhrunxdvcJh
# N2hJd6PrkKoS1yeF844ektrCQDifXcigLiV4JZ0qBXqEKZi2V3mP2yZWK7Dzp703
# DNiYdk9WuVLCtp04qYHnbUFcjGnRuSvExnvPnPp44pMadqJpddNQ5EQSviANnqlE
# 0PjlSXcIWiHFtM+YlRpUurm8wWkZus8W8oM3NG6wQSbd3lqXTzON1I13fXVFoaVY
# JmoDRd7ZULVQjK9WvUzF4UbFKNOt50MAcN7MmJ4ZiQPq1JE3701S88lgIcRWR+3a
# EUuMMsOI5ljitts++V+wQtaP4xeR0arAVeOGv6wnLEHQmjNKqDbUuXKWfpd5OEhf
# ysLcPTLfddY2Z1qJ+Panx+VPNTwAvb6cKmx5AdzaROY63jg7B145WPR8czFVoIAR
# yxQMfq68/qTreWWqaNYiyjvrmoI1VygWy2nyMpqy0tg6uLFGhmu6F/3Ed2wVbK6r
# r3M66ElGt9V/zLY4wNjsHPW2obhDLN9OTH0eaHDAdwrUAuBcYLso/zjlUlrWrBci
# I0707NMX+1Br/wd3H3GXREHJuEbTbDJ8WC9nR2XlG3O2mflrLAZG70Ee8PBf4NvZ
# rZCARK+AEEGKMIIG5jCCBM6gAwIBAgIQd70OA6G3CPhUqwZyENkERzANBgkqhkiG
# 9w0BAQsFADBTMQswCQYDVQQGEwJCRTEZMBcGA1UEChMQR2xvYmFsU2lnbiBudi1z
# YTEpMCcGA1UEAxMgR2xvYmFsU2lnbiBDb2RlIFNpZ25pbmcgUm9vdCBSNDUwHhcN
# MjAwNzI4MDAwMDAwWhcNMzAwNzI4MDAwMDAwWjBZMQswCQYDVQQGEwJCRTEZMBcG
# A1UEChMQR2xvYmFsU2lnbiBudi1zYTEvMC0GA1UEAxMmR2xvYmFsU2lnbiBHQ0Mg
# UjQ1IENvZGVTaWduaW5nIENBIDIwMjAwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAw
# ggIKAoICAQDWQk3540/GI/RsHYGmMPdIPc/Q5Y3lICKWB0Q1XQbPDx1wYOYmVPpT
# I2ACqF8CAveOyW49qXgFvY71TxkkmXzPERabH3tr0qN7aGV3q9ixLD/TcgYyXFus
# UGcsJU1WBjb8wWJMfX2GFpWaXVS6UNCwf6JEGenWbmw+E8KfEdRfNFtRaDFjCvhb
# 0N66WV8xr4loOEA+COhTZ05jtiGO792NhUFVnhy8N9yVoMRxpx8bpUluCiBZfomj
# WBWXACVp397CalBlTlP7a6GfGB6KDl9UXr3gW8/yDATS3gihECb3svN6LsKOlsE/
# zqXa9FkojDdloTGWC46kdncVSYRmgiXnQwp3UrGZUUL/obLdnNLcGNnBhqlAHUGX
# Yoa8qP+ix2MXBv1mejaUASCJeB+Q9HupUk5qT1QGKoCvnsdQQvplCuMB9LFurA6o
# 44EZqDjIngMohqR0p0eVfnJaKnsVahzEaeawvkAZmcvSfVVOIpwQ4KFbw7MueovE
# 3vFLH4woeTBFf2wTtj0s/y1KiirsKA8tytScmIpKbVo2LC/fusviQUoIdxiIrTVh
# lBLzpHLr7jaep1EnkTz3ohrM/Ifll+FRh2npIsyDwLcPRWwH4UNP1IxKzs9jsbWk
# EHr5DQwosGs0/iFoJ2/s+PomhFt1Qs2JJnlZnWurY3FikCUNCCDx/wIDAQABo4IB
# rjCCAaowDgYDVR0PAQH/BAQDAgGGMBMGA1UdJQQMMAoGCCsGAQUFBwMDMBIGA1Ud
# EwEB/wQIMAYBAf8CAQAwHQYDVR0OBBYEFNqzjcAkkKNrd9MMoFndIWdkdgt4MB8G
# A1UdIwQYMBaAFB8Av0aACvx4ObeltEPZVlC7zpY7MIGTBggrBgEFBQcBAQSBhjCB
# gzA5BggrBgEFBQcwAYYtaHR0cDovL29jc3AuZ2xvYmFsc2lnbi5jb20vY29kZXNp
# Z25pbmdyb290cjQ1MEYGCCsGAQUFBzAChjpodHRwOi8vc2VjdXJlLmdsb2JhbHNp
# Z24uY29tL2NhY2VydC9jb2Rlc2lnbmluZ3Jvb3RyNDUuY3J0MEEGA1UdHwQ6MDgw
# NqA0oDKGMGh0dHA6Ly9jcmwuZ2xvYmFsc2lnbi5jb20vY29kZXNpZ25pbmdyb290
# cjQ1LmNybDBWBgNVHSAETzBNMEEGCSsGAQQBoDIBMjA0MDIGCCsGAQUFBwIBFiZo
# dHRwczovL3d3dy5nbG9iYWxzaWduLmNvbS9yZXBvc2l0b3J5LzAIBgZngQwBBAEw
# DQYJKoZIhvcNAQELBQADggIBAAiIcibGr/qsXwbAqoyQ2tCywKKX/24TMhZU/T70
# MBGfj5j5m1Ld8qIW7tl4laaafGG4BLX468v0YREz9mUltxFCi9hpbsf/lbSBQ6l+
# rr+C1k3MEaODcWoQXhkFp+dsf1b0qFzDTgmtWWu4+X6lLrj83g7CoPuwBNQTG8cn
# qbmqLTE7z0ZMnetM7LwunPGHo384aV9BQGf2U33qQe+OPfup1BE4Rt886/bNIr0T
# zfDh5uUzoL485HjVG8wg8jBzsCIc9oTWm1wAAuEoUkv/EktA6u6wGgYGnoTm5/Db
# hEb7c9krQrbJVzTHFsCm6yG5qg73/tvK67wXy7hn6+M+T9uplIZkVckJCsDZBHFK
# EUtaZMO8eHitTEcmZQeZ1c02YKEzU7P2eyrViUA8caWr+JlZ/eObkkvdBb0LDHgG
# K89T2L0SmlsnhoU/kb7geIBzVN+nHWcrarauTYmAJAhScFDzAf9Eri+a4OFJCOHh
# W9c40Z4Kip2UJ5vKo7nb4jZq42+5WGLgNng2AfrBp4l6JlOjXLvSsuuKy2MIL/4e
# 81Yp4jWb2P/ppb1tS1ksiSwvUru1KZDaQ0e8ct282b+Awdywq7RLHVg2N2Trm+GF
# F5opov3mCNKS/6D4fOHpp9Ewjl8mUCvHouKXd4rv2E0+JuuZQGDzPGcMtghyKTVT
# gTTcMIIHHDCCBQSgAwIBAgIMSUXsaWVAFuihgz78MA0GCSqGSIb3DQEBCwUAMFkx
# CzAJBgNVBAYTAkJFMRkwFwYDVQQKExBHbG9iYWxTaWduIG52LXNhMS8wLQYDVQQD
# EyZHbG9iYWxTaWduIEdDQyBSNDUgQ29kZVNpZ25pbmcgQ0EgMjAyMDAeFw0yMjAz
# MDIxMTQ4MzlaFw0yNDA2MTQxNDMwNDRaMIGJMQswCQYDVQQGEwJVUzERMA8GA1UE
# CBMITmV3IFlvcmsxETAPBgNVBAcTCE5ldyBZb3JrMRYwFAYDVQQKEw1TRU1QRVJJ
# UyBJTkMuMRYwFAYDVQQDEw1TRU1QRVJJUyBJTkMuMSQwIgYJKoZIhvcNAQkBFhVj
# b2Rlc2lnbkBzZW1wZXJpcy5jb20wggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIK
# AoICAQCvq2XdKWZ+xqIQ58x22njO9MSseih/t2TsnekKeiimUgSIKHG7TLypz2Vx
# 0+PumvxEm9JsbXXQKx9XobNZ69lRUlaZCq8Tia6DMvGEUAEvi3SvwdlJJr+AowSd
# 1evdJSHB1suaDfwX7K7PIaiIdjnl5wwc9ajPz20FiV7OUhIjYLT4T9FALz9zxJN+
# WlcUJUSmoXAmdjXHmvP6MQNO7whPI2auFvrq7OiA1N2CyXTFqwz1OkTlUqtZIsCD
# fuIWuPQZGPB3+nNN87e1eEfjO3vbwXTge649/7cXcRMuFKyuTWUE3AxX5QFWM8mt
# WujVuu8QefsPzwGJwaRP+oWHT5HmNS7s7wEn7+DggenjIo62n85ySnTliLofjl9f
# flxB10Hq3BYgVsZyNEYBp1hRKRpxQ58ZHMAkpA4liY3chI4klPWGgcIW1H2yqM3S
# lBraTVuT9skaZOua3u5Q8nlRyeXWoeBmQ8PlH0RFdeNnTRxfmY7HmXSCnG+D7TVH
# hzJPLGBHMC4FTjqro/wRKHiGLIkz6edqjz54TxKv9U39ULsIK0sQZaXb8STUp6eK
# K5lKt0wWedojQbi2qob3uZIgGg+4rAEKT4Wm8ZdDy7eN3aZTw/i5mjiEfwyJvgvz
# WT/yhJz6+ZDMQGIFJj9L2DaPnUSejLMC7K8kyZwJUXVGn1NRTQIDAQABo4IBsTCC
# Aa0wDgYDVR0PAQH/BAQDAgeAMIGbBggrBgEFBQcBAQSBjjCBizBKBggrBgEFBQcw
# AoY+aHR0cDovL3NlY3VyZS5nbG9iYWxzaWduLmNvbS9jYWNlcnQvZ3NnY2NyNDVj
# b2Rlc2lnbmNhMjAyMC5jcnQwPQYIKwYBBQUHMAGGMWh0dHA6Ly9vY3NwLmdsb2Jh
# bHNpZ24uY29tL2dzZ2NjcjQ1Y29kZXNpZ25jYTIwMjAwVgYDVR0gBE8wTTBBBgkr
# BgEEAaAyATIwNDAyBggrBgEFBQcCARYmaHR0cHM6Ly93d3cuZ2xvYmFsc2lnbi5j
# b20vcmVwb3NpdG9yeS8wCAYGZ4EMAQQBMAkGA1UdEwQCMAAwRQYDVR0fBD4wPDA6
# oDigNoY0aHR0cDovL2NybC5nbG9iYWxzaWduLmNvbS9nc2djY3I0NWNvZGVzaWdu
# Y2EyMDIwLmNybDATBgNVHSUEDDAKBggrBgEFBQcDAzAfBgNVHSMEGDAWgBTas43A
# JJCja3fTDKBZ3SFnZHYLeDAdBgNVHQ4EFgQUeXYlhOREXUlIPR2ZpkQmsxInWlkw
# DQYJKoZIhvcNAQELBQADggIBALVBZWrw/axZwZgcg+pO0wYi/phXxE1hUOxLaeRJ
# SxTEYZk7QasYoM2fR6mjUzV1da1sQKSK9OtUDbHcq7/JXKwcdKWIttwv9AI+RtdP
# yGvezvVfne1sBCn3qIxK3/5FRFdYftucE4It87UF4f25rS5FgGnLc5h+4MQgKjCv
# hI1F/aJjTBKhZnzlCwGUyAssXKYmWf0+PDxJixU5iTB8yK/VpPu4LFWWRi0pb1uS
# bJse4qIR25DBJ+zkbN6BIUz5Zx8LgmoGFVdEHFCWNfndjWtvd4DwJUtMdk9Wpdcz
# x2LrbzLUjKVN1PNdyuIWMKYxhnSt74U2VUFPoqEn6c/6lxKattXL2qD8FfV9APlc
# ZPrdV1Cnip9Mrbm5YdYebQaU4xH9LILkcSakBJSQvm0ev6f70ahHJLwiNCinftEn
# WEqgFeUfRrLJBYe8tCMIzkfH4BFIOrcd16ordOgC5QMn4bmqCvQE/df0Cngrt9Kf
# ynSBp+kx1IFZGeZ8iE9rQThcQwD75dC1/L6ADiev/TMPTm4H6+lKWL3umGvp/d25
# p+Y0lsfjTPvGWDZ65MF3sKRS0jcrAWrSm92CWfReyOXk2FHjJjtj2hAiNZ32igVh
# arGemFH0l5wHc/4KRUDcvtfCq7k8hdJn5s+EXlrzI01OFiabyDbR2Xe8JpmJfn9E
# e+3yMYIGNjCCBjICAQEwaTBZMQswCQYDVQQGEwJCRTEZMBcGA1UEChMQR2xvYmFs
# U2lnbiBudi1zYTEvMC0GA1UEAxMmR2xvYmFsU2lnbiBHQ0MgUjQ1IENvZGVTaWdu
# aW5nIENBIDIwMjACDElF7GllQBbooYM+/DANBglghkgBZQMEAgEFAKB8MBAGCisG
# AQQBgjcCAQwxAjAAMBkGCSqGSIb3DQEJAzEMBgorBgEEAYI3AgEEMBwGCisGAQQB
# gjcCAQsxDjAMBgorBgEEAYI3AgEVMC8GCSqGSIb3DQEJBDEiBCAdYAzsGOcvQTgM
# CRAjb/I0LIFnaTmHtpngUCSXvW2yCzANBgkqhkiG9w0BAQEFAASCAgA3SnzSlmVD
# m3KQ+s+StzsdfeOXVlYFJRQRvcirBNQgIj6SVJdYG9MqB6zy2mWfkKYb8XQ/Iwxs
# miWOMWl7NUiXPjUv14jV4LMZwl1sKq85tfOkEeHHAkyXksmRr/sVqSRUCZng7Hp1
# 7yl3HXUApF0klHfjlsUVFJWAvPqI0b6H5iNUaJM4qJAhxKbzBPCz5n3alWR/Ukfc
# ndFSP4MRB80alDTYap6BgbWL6xgGDDNG1Bp9f1GLS/I94hyRvN4wDQ/UWGw0TqI1
# WgOciIYRE8RP5UJ+woLuDyBOzYRjaIKEOj97q/pfRBd45SIipdNqEaRj+IjXuAa4
# oLnY2NdGdLb/aJHVgPjRoaLvhUoeHDYdxUbmVg2W/LTM0mIiQv7fedfJpwQGXVRs
# sE//aZJgYkLsFU/TXpcpVVHd5wLrUhBi2m9Z6XDy0etwwT2CyNpU3sbD5y9VQ1ib
# DydBgxSO0w73PHAD7maV2d6/s9ge6mWDUb1ZS/7btDnYIy57KYb7YyUoIs5y3yrs
# 9zFCw0/ycKhBaCiXEAKRxg3vZEGfTJLYqZG/Zn6EOivl56MfEcpx8yEyAFj+4MZO
# Pb32Qyt6QB5FvZHv7GSpSTHwZjyf16EmyUJsNYy56plaMvg4YCsO8Zf8YQqRyI4l
# M6B9BYBTvAC1JLyt1BAUkNiN3muyCLN5HKGCAyAwggMcBgkqhkiG9w0BCQYxggMN
# MIIDCQIBATB3MGMxCzAJBgNVBAYTAlVTMRcwFQYDVQQKEw5EaWdpQ2VydCwgSW5j
# LjE7MDkGA1UEAxMyRGlnaUNlcnQgVHJ1c3RlZCBHNCBSU0E0MDk2IFNIQTI1NiBU
# aW1lU3RhbXBpbmcgQ0ECEAVEr/OUnQg5pr/bP1/lYRYwDQYJYIZIAWUDBAIBBQCg
# aTAYBgkqhkiG9w0BCQMxCwYJKoZIhvcNAQcBMBwGCSqGSIb3DQEJBTEPFw0yMzEy
# MDUxMTM4MjRaMC8GCSqGSIb3DQEJBDEiBCCblCmbQgDH42t15ndvh5lSBYPxL67g
# kGzea+cLjX4VQzANBgkqhkiG9w0BAQEFAASCAgBkmi7EBdEyUs5ywFiGuJSG1iPn
# iflCrtO10naH7RIY4SIPoJTORRD9cW6bVWt6h+yVYNZVqzLxrPPgIMI7Q8lgSYiB
# 6Lw7iVPKCQgNydqbdHxaNQ+L3D2fAbt3k+78OhFN5BMLEDHGVDZ4/8Ld1hnXc7LR
# hm7sb6ixg1dtP0PvLAGFAV30BubH5AjEmq01ARj39y9R05biq+paQTKLkLjPsmk7
# GcniHK9MYX6uf7BbM1odghKwwTRnSPWwGKuToLdUYVZpP+vkXliNfZR2GraiNDXr
# VwjZFPbLNyCKUGTEvKKBVPEfLk628qQ6tfiI9ia7s3pd4tJMtqyjxgyPqzqjycGW
# mbPBQFYrC7phUreht+eWNMAgFuCuxhVh33BNN1nMNVkcCGIr/EW7Pnk8CatGo78V
# oaFoHIL9cB8HhmjV7Jj6Gf4LHz1sJrc1NMyyVmg90P24GlGbhPL4eYf69DDGYKWV
# A0RNaKgoJuOlrsr5duMc15LHJXe3C2cLaWfMqFICQDzb1TYeH4zHsb6orcNt7JRO
# Wyebyi2cAHU5FkaGgE0n7TNHiziZv9WJhQ18WS5LVDCdwaY6FthgOhxzYLuqVhCF
# rHd1SDcUWVydyjEEoCIAk0JesHTw8j9Vc6vN4M8d181iqntZiQ994nWD7nzRKYB9
# 46K1M9CkAmjJiFjU3Q==
# SIG # End signature block
